/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the SignatureResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SignatureResponse{}

// SignatureResponse struct for SignatureResponse
type SignatureResponse struct {
	SignLink string `json:"sign_link"`
}

// NewSignatureResponse instantiates a new SignatureResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSignatureResponse(signLink string) *SignatureResponse {
	this := SignatureResponse{}
	this.SignLink = signLink
	return &this
}

// NewSignatureResponseWithDefaults instantiates a new SignatureResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSignatureResponseWithDefaults() *SignatureResponse {
	this := SignatureResponse{}
	return &this
}

// GetSignLink returns the SignLink field value
func (o *SignatureResponse) GetSignLink() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SignLink
}

// GetSignLinkOk returns a tuple with the SignLink field value
// and a boolean to check if the value has been set.
func (o *SignatureResponse) GetSignLinkOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SignLink, true
}

// SetSignLink sets field value
func (o *SignatureResponse) SetSignLink(v string) {
	o.SignLink = v
}

func (o SignatureResponse) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SignatureResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["sign_link"] = o.SignLink
	return toSerialize, nil
}

type NullableSignatureResponse struct {
	value *SignatureResponse
	isSet bool
}

func (v NullableSignatureResponse) Get() *SignatureResponse {
	return v.value
}

func (v *NullableSignatureResponse) Set(val *SignatureResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableSignatureResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableSignatureResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSignatureResponse(val *SignatureResponse) *NullableSignatureResponse {
	return &NullableSignatureResponse{value: val, isSet: true}
}

func (v NullableSignatureResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSignatureResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


